<?php

namespace App\Forms;

use App\Forms\CommonForm;

class MylogForm extends CommonForm
{
  public function __construct()
  {
    parent::__construct();
  }
  public function form_init_process(string $action, array &$formDatas = []): void
  {
    parent::form_init_process($action, $formDatas);
    $fields = ['title', 'content', 'status'];
    $filters = ['user_uid', 'status'];
    $indexFilter = $filters;
    $batchjobFilters = $filters;
    switch ($action) {
      case 'view':
        $fields = [...$fields, 'status', 'created_at'];
        break;
      case 'index':
      case 'download':
        $fields = [...$fields, 'status', 'created_at'];
        break;
    }
    $this->setFormFields($fields);
    $this->setFormRules($fields);
    $this->setFormFilters($filters);
    $this->setFormOptions($filters, $formDatas);
    $this->setIndexFilters($indexFilter);
    $this->setBatchjobFilters($batchjobFilters);
  }
  public function getFormRule(string $field, array $formRules): array
  {
    switch ($field) {
      case "user_uid":
        $formRules[$field] = "required|int";
        break;
      case "title":
        $formRules[$field] = "required|trim|string";
        break;
      case "content":
        $formRules[$field] = "permit_empty|trim|string";
        break;
      default:
        $formRules = parent::getFormRule($field, $formRules);
        break;
    }
    return $formRules;
  }
}
